; 

    .486                      ; create 32 bit code
    .model flat, stdcall      ; 32 bit memory model
    option casemap :none      ; case sensitive

    include tstlabel.inc      ; local includes for this file

    include lib\ttlbl.inc
    includelib lib\ttlbl.lib

    Static PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
      lpttLblProc dd ?
      hTxtFont dd ?
      hClearLbl dd ?

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandle, NULL)
      mov CommandLine, rv(GetCommandLine)
      mov hIcon,       rv(LoadIcon,hInstance,500)
      mov hCursor,     rv(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD,hBrush:DWORD

    STRING szClassName,"Label_Demo_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------

    mov hBrush, rv(CreateSolidBrush,00FF0000h)

    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,hBrush

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 60, 40

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..
    LOCAL hBmp  :DWORD
    LOCAL hStat :DWORD

    Switch uMsg
      Case WM_COMMAND

      Case WM_CREATE

        mov hStat, rv(Static,hWin,20,20,2000)
        mov hBmp, rv(LoadImage,hInstance,600,IMAGE_BITMAP,0,0,LR_DEFAULTSIZE)
        invoke SendMessage,hStat,STM_SETIMAGE,IMAGE_BITMAP,hBmp
        mov hTxtFont, GetFontHandle("times new roman",20,500)

        .data
          tmsg db "This is an example of a modified STATIC control that has no "
               db "border, has a transparent background and it displays the text with "
               db "a 1 pixel wide shadow behind it. You can set the font, text colour "
               db "and text alignment to suit your interface. This transparent label "
               db "will display correctly over different client area colours and other "
               db "STATIC controls that display a bitmap.",0
          pmsg dd tmsg
        .code

        mov hClearLbl, rv(ttLabel,pmsg,hWin,hInstance,30,30,380,150,00DDDDFFh,-1)

        invoke SendMessage,hClearLbl,WM_SETFONT,hTxtFont,TRUE

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_CLOSE
        invoke DeleteObject,hTxtFont

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

Static proc hParent:DWORD,tx:DWORD,ty:DWORD,ID:DWORD
                 
    fn CreateWindowEx,0,"STATIC",NULL, \
            WS_CHILD or WS_VISIBLE or SS_BITMAP, \
            tx,ty,0,0,hParent,ID,hInstance,NULL
    ret

Static endp

; 
















end start
